cd $TOP
file="$objdir/config.h"

echo Extracting $file
rm -f $file

ASMFILE=''                 # Inline, for sparc/gcc only
case "$CC" in
*gcc|*g++)
  case "$asmarch" in
  m68k)     ASMFILE='';;
  sparcv9)  ASMFILE="asmsparcv9.h";;
  sparcv8*) ASMFILE="asmsparcv8.h"; fast='Fast ';;
  esac;;
esac
case "$optimization" in
  full) ;;
  *) debuginfo=" -- $optimization";;
esac

cat > $file << EOT
/*
 *  This file was created by Configure. Any change made to it will be lost
 *  next time configure is run.
 */
#ifndef __CONFIG_H__
#define __CONFIG_H__

#define UNIX

#define GPHELP "$miscdir/gphelp"

#define PARIVERSION "GP/PARI CALCULATOR Version ${revision}"
#ifdef __cplusplus
# define PARIINFO "(${fast}C++ ${pretty}${debuginfo})"
#else
# define PARIINFO "(${fast}${pretty}${debuginfo})"
#endif
EOT

if test ! -z "$ASMFILE"; then
cat >> $file <<EOT

/*
 *  Inlines some core functions + use registers instead of global
 *  variables to store some heavily used values.
 *
 *  This is at least 20% faster, but not intensively tested yet.
 *
 *  COMMENT OUT the following 2 lines if you choose NOT to use gcc/g++
 */

#define ASMFILE "$src_dir/asmfiles/$ASMFILE"
#define FASTASM
EOT
fi

if test ! -z "$gunzip"; then
  cat >> $file << EOT

/* 
 *   Location of GNU gunzip program (enables reading of .Z and .gz files
 *   with \r commands).
 *
 */

#define GNUZCAT
#define ZCAT "$gunzip -c"

EOT
else if test ! -z "$zcat"; then
  cat >> $file << EOT

/* 
 *   Location of zcat program (enables reading of .Z files with \r commands).
 *
 */

#define ZCAT "$zcat"

EOT
  fi
fi

case $which_rl in
  1) cat >> $file <<EOT

/*
 * Use GNU readline library (version 1.0).
 *
 *     The use of the readline and history library (suggested
 *   to us by E. Roeder) is not documented but is similar to emacs commands.
 *   However note that it is incompatible with SUN commandtools (but not with
 *   shelltools).
 *
 *   Note: this library is incompatible with sunview. This has been fixed in
 *   readline 2.0 
 */

#define READLINE

EOT
;;

  2) cat >> $file <<EOT

/*
 * Use GNU readline library (version 2.0).
 *
 *     The use of the readline and history library (suggested to us by
 *   E. Roeder) is not documented but is similar to emacs commands. However
 *   note that it is incompatible with SUN commandtools (but not with
 *   shelltools).
 *
 */
  
#define READLINE2
#define READLINE

EOT
;;
esac
case "$CPPF_defined" in
yes) echo '#define CPPFunction_defined' >> $file;;
esac

case "$sizeof_long" in
8) echo '#define LONG_IS_64BIT' >> $file;;
esac

case "$has_exp2" in
no) echo '#define NOEXP2' >> $file;;
esac

case "$has_getrusage" in
yes) echo '#define USE_GETRUSAGE 1' >> $file;;
  *) case "$has_times" in
     yes) echo '#define USE_TIMES 1' >> $file;;
       *) case "$has_ftime" in
 	  yes) echo '#define USE_FTIME 1' >> $file;;
	  esac;;
     esac;;
esac

case $has_xmalloc in
yes) echo '#define HAS_XMALLOC' >> $file;;
esac

case $osname in
  solaris) echo '#define SOLARIS' >> $file;;
esac

case $asmarch in
  none) echo '#define __HAS_NO_ASM__' >> $file;;
  hppa) echo '#define __HPPA__' >> $file;;
  m68k) echo '#define __M68K__' >> $file;;
esac

case $little_endian in
  yes) cat >> $file << EOT
#ifndef LITTLE_ENDIAN
#  define LITTLE_ENDIAN
#endif
EOT
;;
esac

echo '#endif' >> $file
