/********************************************************************/
/********************************************************************/
/**                                                                **/
/**                  BIBLIOTHEQUE  MATHEMATIQUE                    **/
/**                     (deuxieme partie)                          **/
/**                                                                **/
/**                     Copyright Babe Cool                        **/
/**                                                                **/
/********************************************************************/
/********************************************************************/
/* $Id: bibli2.c,v 1.914.7.2 1997/01/20 11:33:21 karim Exp karim $ */
#include "genpari.h"

/********************************************************************/
/**                                                                **/
/**                        ITERATIONS                              **/
/**                                                                **/
/********************************************************************/

void
forpari(entree *ep, GEN a, GEN b, char *ch)
{
  long la,lx,i,e, av = avma, tx = typ(a);
  GEN p1;

  if (! is_intreal_t(tx)) err(forer1);
  if (tx==t_INT)
  {
    la = lx = lgefint(a); if (lx<3) lx=3;
    if (!gcmp0(b)) { e = (gexpo(b)>>TWOPOTBITS_IN_LONG) + 3; if (e>lx) lx=e; }
    p1=newbloc(lx); for (i=0; i<la; i++) p1[i]=a[i];
    setlg(p1,lx); p1[-1] = (long) ep->value; ep->value = (void*) p1;
  }
  else newvalue(ep,a);
  p1 = (GEN) ep->value;
  while (gcmp(p1,b)<=0)
  {
    lisseq(ch); gaddgsz(p1,1,p1); p1 = (GEN) ep->value; avma=av;
  }
  killvalue(ep);
}

void
forstep(entree *ep, GEN a, GEN b, GEN s, char *ch)
{
  long lx,la,s1,i,e, av = avma, tx = typ(a);
  GEN p1;

  s1=gsigne(s); if (!s1) err(forer2);
  if (! is_intreal_t(tx)) err(forer1);
  if (tx==t_INT)
  {
    la = lx = lgefint(a); if (lx<3) lx=3;
    if (!gcmp0(b)) { e = (gexpo(b)>>TWOPOTBITS_IN_LONG) + 3; if (e>lx) lx=e; }
    if (typ(s)==t_REAL)
    {
      p1=cgetr(lg(s)); affir(a,p1); newvalue(ep,p1); avma=av;
    }
    else
    {
      p1=newbloc(lx); for (i=0; i<la; i++) p1[i]=a[i];
      setlg(p1,lx); p1[-1]=(long)ep->value; ep->value=(void*)p1;
    }
  }
  else newvalue(ep,a);
  p1=(GEN)ep->value;
  if (s1>0)
    while (gcmp(p1,b) <= 0)
    {
      lisseq(ch); gaddz(p1,s,p1); p1 = (GEN) ep->value; avma = av;
    }
  else
    while (gcmp(p1,b)>= 0)
    {
      lisseq(ch); gaddz(p1,s,p1); p1 = (GEN) ep->value; avma = av;
    }
  killvalue(ep);
}

void
forprime(entree *ep, GEN a, GEN b, char *ch)
{
  GEN p1;
  long av=avma,prime=0;
  byteptr p=diffptr;

  newvalue(ep,gun); p1 = (GEN)ep->value;
  while (*p && gcmpgs(a,prime) > 0) prime += *p++;
  if (!*p) err(recprimer);
  affsi(prime,p1);
  while (gcmp(p1,b)<=0)
  {
    if (!*p) err(recprimer);
    lisseq(ch); addsiz(*p++,p1,p1); p1 = (GEN) ep->value; avma=av;
  }
  killvalue(ep);
}

void
fordiv0(GEN a, entree *ep,char *ch)
{
  fordiv(ep,a,ch);
}

void
fordiv(entree *ep, GEN a, char *ch)
{
  GEN p1,t=divisors(a);
  long i,av2,l=lg(t),av=avma;

  newvalue(ep,a); p1=(GEN)ep->value; av2=avma;
  for (i=1; i<l; i++)
  {
    gaffect((GEN)t[i],p1); lisseq(ch); p1 = (GEN) ep->value; avma=av2;
  }
  avma=av; killvalue(ep);
}

void
forvec(entree *ep, GEN x, char *ch)
{
  GEN p1,y,oldy,a,b,c,pinit;
  long av=avma,tx=typ(x),ty,n,e,la,lx,i,j;

  if (!is_vec_t(tx)) err(talker,"not a vector in forvec");
  n=lg(x)-1; if (!n) return;

  y=newbloc(n+1); y[0] = evaltyp(t_VEC) | evalpere(1) | evallg(n+1);
  for (i=1; i<=n; i++)
  {
    c=(GEN)x[i]; ty=typ(c);
    if (! is_vec_t(ty) || lg(c)!=3)
      err(talker,"not a vector of two-component vectors in forvec");
    a=(GEN)c[1]; b=(GEN)c[2];
    if (gcmp(a,b)>0) { avma=av; return; }
    if (typ(a)==t_INT)
    {
      la=lx=lgefint(a); if (lx<3) lx=3;
      if (!gcmp0(b)) { e=(gexpo(b)>>TWOPOTBITS_IN_LONG)+3; if (e>lx) lx=e; }
      p1=newbloc(lx); for (j=0; j<la; j++) p1[j]=a[j];
      setlg(p1,lx);
    }
    else p1=gclone(a);
    y[i]=(long)p1;
  }
  y[-1] = (long) ep->value; ep->value = (void*) y; pinit=gclone(y);

  oldy = y;
  do
  {
    lisseq(ch); i=n+1;
    if ((GEN) ep->value != y) { oldy = y; y = (GEN) ep->value; }
    do
    {
      i--;
      if (i<n) gaffect((GEN)pinit[i+1],(GEN)y[i+1]);
      if (i) gaddgsz((GEN)y[i],1,(GEN)y[i]);
    }
    while ( i && gcmp((GEN)y[i],gmael(x,i,2)) > 0 );
    avma=av;
  }
  while (i);
  for (i=1; i<=n; i++) killbloc((GEN)oldy[i]);
  killbloc(pinit); killvalue(ep);

}

/********************************************************************/
/**                                                                **/
/**       SOMMES,PRODUITS,VECTEURS,MATRICES ET RECURRENCES         **/
/**                                                                **/
/********************************************************************/

GEN
direuler(entree *ep, GEN a, GEN b, char *ch)
{
  GEN p1,y,y1,s,z,polnum,polden,c0;
  long av,av1,tetpil,limite=(avma+bot)>>1,prime=0,q,n,i,j,k,k1,tx,lx;
  byteptr p=diffptr;

  if (gcmpgs(b,2)<0) { y=cgetg(2,t_VEC); y[1]=un; return y; }
  av1=avma; n=itos(gmin(b,stoi(MAXHALFULONG-1))); b=stoi(n);
  y1=cgetg(n+1,t_VEC); av=avma;
  y=cgetg(n+1,t_VEC); y[1]=un; for (i=2; i<=n; i++) y[i]=zero;
  newvalue(ep,gun); p1 = (GEN) ep->value;
  while ( *p && gcmpgs(a,prime)>0 ) prime += *p++;
  if (!*p) err(recprimer);
  affsi(prime,p1); tetpil=avma;
  while (gcmp(p1,b)<=0)
  {
    if (!*p) err(recprimer);
    if (avma<limite) { tetpil=avma; y=gerepile(av,tetpil,gcopy(y)); }
    z=lisexpr(ch); polnum=numer(z); polden=denom(z);
    tx = typ(polnum);
    if (is_scalar_t(tx))
    {
      if (!gcmp1(polnum))
	err(talker,"constant term not equal to 1 in direuler");
    }
    else
    {
      if (tx != t_POL) err(talker,"incorrect type in direuler");
      c0=truecoeff(polnum,0);
      if (!gcmp1(c0)) err(talker,"constant term not equal to 1 in direuler");
      for (i=1; i<=n; i++) y1[i]=y[i];
      prime=itos(p1); q=prime; j=1; lx=lgef(polnum)-3;
      while (q<=n && j<=lx)
      {
	c0=(GEN)polnum[j+2];
	if (!gcmp0(c0))
	  for (k=1,k1=q; k1<=n; k1+=q,k++)
	    y[k1] = (long) gadd( (GEN)y[k1], gmul(c0,(GEN)y1[k]) );
	q*=prime; j++;
      }
    }

    tx=typ(polden);
    if (is_scalar_t(tx))
    {
      if (!gcmp1(polden))
	err(talker,"constant term not equal to 1 in direuler");
    }
    else
    {
      if (tx != t_POL) err(talker,"incorrect type in direuler");
      c0=truecoeff(polden,0);
      if (!gcmp1(c0)) err(talker,"constant term not equal to 1 in direuler");
      prime=itos(p1); lx=lgef(polden)-3;
      for (i=prime; i<=n; i+=prime)
      {
	s=gzero; k=i; j=1;
	while (!(k%prime) && j<=lx)
	{
	  c0=(GEN)polden[j+2]; k/=prime; j++;
	  if (!gcmp0(c0)) s=gadd(s,gmul(c0,(GEN)y[k]));
	 }
	y[i]=lsub((GEN)y[i],s);
      }
    }
    addsiz(*p++,p1,p1);
  }
  killvalue(ep); tetpil=avma;
  return gerepile(av1,tetpil,gcopy(y));
}

GEN
somme(entree *ep, GEN a, GEN b, char *ch, GEN x)
{
  GEN   y,z,p1;
  long  av = avma,tetpil,limite=(avma+bot)/2;

  newvalue(ep,gun); p1 = (GEN)ep->value; gaffect(a, p1);
  y = x;
  tetpil = avma;
  if (gcmp(a,b)>0)
  {
    gaddgsz(p1,-1,p1);
    while (gcmp(p1,b)>0)
    {
      if (avma<limite) { tetpil=avma; y=gerepile(av,tetpil,gcopy(y)); }
      z=gneg(lisexpr(ch));
      tetpil=avma; y=gadd(y,z);
      gaddgsz(p1,-1,p1);
    }
  }
  else
    do
    {
      if (avma<limite) { tetpil=avma; y=gerepile(av,tetpil,gcopy(y)); }
      z=lisexpr(ch);
      tetpil=avma; y=gadd(y,z);
      gaddgsz(p1,1,p1);
    }
    while (gcmp(p1,b)<=0);
  killvalue(ep);
  return gerepile(av,tetpil,y);
}

GEN
suminf(entree *ep, GEN a, char *ch, long prec)
{
  GEN   y,z,p1;
  long  av=avma,tetpil,limite=(bot+avma)/2,fl=0;

  newvalue(ep,gun); p1 = (GEN)ep->value; gaffect(a, p1);
  y=gun;
  do
  {
    if (avma < limite) { tetpil = avma; y=gerepile(av,tetpil,gcopy(y)); }
    z=lisexpr(ch); y=gadd(y,z);
    gaddgsz(p1,1,p1);
    if ((!gcmp0(z))&&(gexpo(z)>gexpo(y)-((prec-2)<<TWOPOTBITS_IN_LONG)-5)) fl=0;
    else fl++;
  }
  while (fl<3);
  killvalue(ep);
  tetpil=avma; return gerepile(av,tetpil,gsubgs(y,1));
}

GEN
produit(entree *ep, GEN a, GEN b, char *ch, GEN x)
{
  GEN   y,z,p1;
  long  av=avma,tetpil,limite=(av+bot)/2;

  newvalue(ep,gun); p1 = (GEN)ep->value; gaffect(a,p1);
  y = x;
  tetpil = avma;
  if (gcmp(a,b)>0)
  {
    gaddgsz(p1,-1,p1);
    while (gcmp(p1,b)>0)
    {
      if (avma<limite) { tetpil=avma; y=gerepile(av,tetpil,gcopy(y)); }
      z=lisexpr(ch);
      tetpil=avma; y=gdiv(y,z);
      gaddgsz(p1,-1,p1);
    }
  }
  else
    do
    {
      if (avma<limite) { tetpil=avma; y=gerepile(av,tetpil,gcopy(y)); }
      z=lisexpr(ch);
      tetpil=avma; y=gmul(y,z);
      gaddgsz(p1,1,p1);
    }
    while (gcmp(p1,b)<=0);
  killvalue(ep);
  return gerepile(av,tetpil,y);
}

GEN
prodinf0(entree *ep, GEN a, char *ch, long flag, long prec)
{
  switch(flag)
  {
    case 0: return prodinf(ep,a,ch,prec);
    case 1: return prodinf1(ep,a,ch,prec);
  }
  err(flagerr);
  return NULL; /* not reached */
}

GEN
prodinf(entree *ep, GEN a, char *ch, long prec)
{
  GEN   y,z,p1;
  long  av=avma,tetpil,limite=(av+bot)>>1,fl=0;

  newvalue(ep, gun); p1=(GEN)ep->value; gaffect(a,p1);
  affsr(1,y=cgetr(prec));
  do
  {
    if (avma<limite) { tetpil=avma; y=gerepile(av,tetpil,gcopy(y)); }
    z=lisexpr(ch); y=gmul(y,z);
    if (DEBUGLEVEL>4) { outerr(p1); outerr(z); outerr(y); }
    gaddgsz(p1,1,p1);
    if (gexpo(gsubgs(z,1)) > -((prec-2)<<TWOPOTBITS_IN_LONG)-5) fl=0;
    else fl++;
  }
  while (fl<3);
  killvalue(ep); tetpil = avma;
  return gerepile(av,tetpil,gcopy(y));
}

GEN
prodinf1(entree *ep, GEN a, char *ch, long prec)
{
  GEN   y,z,p1,p2;
  long  av=avma,tetpil,limite=(av+bot)>>1,fl=0;

  newvalue(ep,gun); p1=(GEN)ep->value; gaffect(a,p1);
  affsr(1,y=cgetr(prec));
  do
  {
    if (avma<limite) { tetpil=avma; y=gerepile(av,tetpil,gcopy(y)); }
    p2=lisexpr(ch); z=gaddsg(1,p2); y=gmul(y,z);
    if (DEBUGLEVEL>4) { outerr(p1); outerr(z); outerr(y); }
    gaddgsz(p1,1,p1);
    if (!gcmp0(z) && gexpo(p2)>-((prec-2)<<TWOPOTBITS_IN_LONG)-5) fl=0;
    else fl++;
  }
  while (fl<3);
  killvalue(ep); tetpil = avma;
  return gerepile(av,tetpil,gcopy(y));
}

GEN
prodeuler(entree *ep, GEN a, GEN b, char *ch, long prec)
{
  GEN y,z,p1;
  long av=avma,tetpil,prime=0;
  byteptr p=diffptr;

  newvalue(ep,gun); p1 = (GEN)ep->value;
  while ((*p)&&gcmpgs(a,prime)>0) prime += *p++;
  if (!*p) err(recprimer);
  affsi(prime,p1); affsr(1,y=cgetr(prec));
  if (gcmp(p1,b)>0)
  {
    if (!gcmp1(gsub(a,b))) err(recer1);
    tetpil=avma;
    y=gcopy(y);
  }
  else
    do
    {
      if (!*p) err(recprimer);
      z=lisexpr(ch);
      tetpil=avma; y=gmul(y,z);
      addsiz(*p++,p1,p1);
    }
    while (gcmp(p1,b)<=0);
  killvalue(ep);
  return gerepile(av,tetpil,y);
}

GEN
vector0(GEN nmax, entree *ep, char *ch)
{
  return vecteur(ep,nmax,ch);
}

GEN
vecteur(entree *ep, GEN nmax, char *ch)
{
  GEN y,p1,t;
  long i,m;

  if (typ(nmax)!=t_INT || signe(nmax)<0) err(vecer1);
  if (gcmpgs(nmax,MAXLEN)>=0)
    err(talker,"too many components in vector");
  m=itos(nmax); y=cgetg(m+1,t_VEC);
  newvalue(ep,gun); p1 = (GEN)ep->value;
  for (i=1; i<=m; i++)
  {
    affsi(i,p1); t=lisexpr(ch);
    y[i] = isonstack(t) ? (long)t : lcopy(t);
  }
  killvalue(ep); return y;
}

GEN
vvector0(GEN nmax, entree *ep, char *ch)
{
  return vvecteur(ep,nmax,ch);
}

GEN
vvecteur(entree *ep, GEN nmax, char *ch)
{
  GEN y=vecteur(ep,nmax,ch);
  settyp(y,t_COL); return y;
}

GEN
matrice0(GEN nlig, GEN ncol,entree *ep1, entree *ep2, char *ch)
{
  return matrice(ep1,ep2,nlig,ncol,ch);
}

GEN
matrice(entree *ep1, entree *ep2, GEN nlig, GEN ncol, char *ch)
{
  GEN   y,z,t,p1,p2;
  long  i,j,m,n,s;

  s=signe(ncol); if (typ(ncol)!=t_INT || s<0) err(mater1);
  if (!s) return cgetg(1,t_MAT);
  s=signe(nlig); if (typ(nlig)!=t_INT || s<0) err(mater1);
  if (gcmpgs(nlig,MAXLEN)>=0)
    err(talker,"too many rows in matrix");
  if (gcmpgs(ncol,MAXLEN)>=0)
    err(talker,"too many columns in matrix");
  n=itos(nlig); m=itos(ncol);
  if (!s)
  { 
    y=cgetg(m+1,t_MAT);
    for (i=1; i<=m; i++) y[i]=lgetg(1,t_COL);
    return y;
  }
  newvalue(ep1,gun); p1 = (GEN)ep1->value;
  newvalue(ep2,gun); p2 = (GEN)ep2->value;
  y=cgetg(m+1,t_MAT);
  for (i=1; i<=m; i++)
  {
    affsi(i,p2);
    z=cgetg(n+1,t_COL); y[i]=(long)z;
    for (j=1; j<=n; j++)
    {
      affsi(j,p1); t=lisexpr(ch);
      z[j] = isonstack(t) ? (long)t : lcopy(t);
    }
  }
  killvalue(ep1); killvalue(ep2); return y;
}

GEN
divsum0(GEN num, entree *ep, char *ch)
{
  return divsomme(ep,num,ch);
}

GEN
divsomme(entree *ep, GEN num, char *ch)
{
  GEN   y,z,p1;
  long  av=avma,tetpil,d,n,d2;

  newvalue(ep, gun); p1 = (GEN)ep->value;
  n=itos(num); /* provisoire */
  tetpil=av=avma; y=gzero;
  for (d = d2 = 1; d2 < n; d++, d2 += d+d-1)
    if (!(n%d))
    {
      affsi(d,p1); y=gadd(y, lisexpr(ch));
      affsi(n/d,p1); z = lisexpr(ch);
      tetpil=avma; y=gadd(y,z);
    }
  if (d2 == n)
  {
    affsi(d,p1); z = lisexpr(ch);
    tetpil=avma; y=gadd(y,z);
  }
  killvalue(ep);
  return gerepile(av,tetpil,y);
}

/********************************************************************/
/**                                                                **/
/**                   CALCUL D'UNE INTEGRALE                       **/
/**                   ( Methode de ROMBERG )                       **/
/**                                                                **/
/********************************************************************/
GEN
romb0(entree *ep, GEN a, GEN b, char *ch, long flag, long prec)
{
  switch(flag)
  {
    case 0: return qromb(ep,a,b,ch,prec);
    case 1: return rombint(ep,a,b,ch,prec);
    case 2: return qromi(ep,a,b,ch,prec);
    case 3: return qromo(ep,a,b,ch,prec);
    default: err(flagerr);
  }
  return NULL; /* not reached */
}

#define JMAX 25
#define JMAXP JMAX+3
#define KLOC 5

GEN
qromb(entree *ep, GEN a, GEN b, char *ch, long prec)
{
  GEN ss,dss,s,h,q1,p1,p2,p3,p4,p,qlint,del,sz,x,sum;
  long av,tetpil,j,j1,j2,lim,l,it,tnm,sig;

  av=avma; l=prec;
  if (typ(a)!=t_REAL) { p=cgetr(prec); gaffect(a,p); a=p; }
  if (typ(b)!=t_REAL) { p=cgetr(prec); gaffect(b,p); b=p; }
  qlint=subrr(b,a); sig=signe(qlint);
  if (!sig) { avma=av; return gzero; }

  if (sig<0) { setsigne(qlint,1); s=a; a=b; b=s; }
  newvalue(ep,cgetr(prec)); q1=(GEN)ep->value;
  p3=cgetg(KLOC+1,t_VEC); p4=cgetg(KLOC+1,t_VEC);
  s=cgetg(JMAXP,t_VEC); h=cgetg(JMAXP,t_VEC);
  affsr(1,(GEN)(h[1]=lgetr(l)));

  gaffect(a,q1); p1=lisexpr(ch);
  gaffect(b,q1); p2=lisexpr(ch);
  s[1]=lmul2n(gmul(qlint,gadd(p1,p2)),-1);
  
  it=1; sz=gmul(gzero,(GEN)s[1]);
  s[2]=s[1]; h[2]=lshiftr((GEN)h[1],-2);
  for (j=2; j<=JMAX; j++)
  {
    tnm=it; del=divrs(qlint,tnm); x=addrr(a,shiftr(del,-1));
    for (sum=sz,j1=1; j1<=it; j1++,x=addrr(x,del))
    {
      affrr(x,q1); p1=lisexpr(ch); sum=gadd(sum,p1);
    }
    it*=2;
    s[j]=lmul2n(gadd((GEN)s[j-1],gmul(sum,del)),-1);

    if (j>=KLOC)
    {
      for (j1=1; j1<=KLOC; j1++)
      {
	p3[j1]=s[j1+j-KLOC]; p4[j1]=h[j1+j-KLOC];
      }
      tetpil=avma; ss=polint(p4,p3,gzero,&dss);
      j1=gexpo(ss); j2=gexpo(dss); lim=((prec-2)<<TWOPOTBITS_IN_LONG)-j-5;
      if (j1-j2 > lim || (j1 < -lim && j2<j1-1))
      {
	if (gcmp0(gimag(ss))) ss=greal(ss);
	tetpil=avma; killvalue(ep);
	return gerepile(av,tetpil,gmulsg(sig,ss));
      }
    }
    s[j+1]=s[j]; h[j+1]=lshiftr((GEN)h[j],-2);
  }
  err(intger2);
  return NULL; /* not reached */
}

GEN
qromo(entree *ep, GEN a, GEN b, char *ch, long prec)
{
  GEN     ss,dss,s,h,q1,sz,p1,p3,p4,p,qlint,del,ddel,x,sum;
  long    av,tetpil,j,j1,j2,lim,l,it,tnm,sig;

  av=avma; l=prec;
  if (typ(a)!=t_REAL) { p=cgetr(prec); gaffect(a,p); a=p; }
  if (typ(b)!=t_REAL) { p=cgetr(prec); gaffect(b,p); b=p; }
  qlint=subrr(b,a); sig=signe(qlint);
  if (!sig) { avma=av; return gzero; }

  if (sig<0) { setsigne(qlint,1); s=a; a=b; b=s; }
  newvalue(ep,cgetr(prec)); q1=(GEN)ep->value;
  p3=cgetg(KLOC+1,t_VEC); p4=cgetg(KLOC+1,t_VEC);
  s=cgetg(JMAXP,t_VEC); h=cgetg(JMAXP,t_VEC);
  affsr(1,(GEN)(h[1]=lgetr(l)));

  affrr(shiftr(addrr(a,b),-1),q1); p1=lisexpr(ch);
  s[1]=lmul(qlint,p1);
  
  it=1; sz=gmul(gzero,(GEN)s[1]);
  s[2]=s[1]; h[2]=ldivrs((GEN)h[1],9);
  for (j=2; j<=JMAX; j++)
  {
    tnm=it; del=divrs(qlint,3*tnm); ddel=shiftr(del,1);
    x=addrr(a,shiftr(del,-1)); sum=sz;
    for (j1=1; j1<=it; j1++)
    {
      affrr(x,q1); p1=lisexpr(ch); sum=gadd(sum,p1); x=addrr(x,ddel);
      affrr(x,q1); p1=lisexpr(ch); sum=gadd(sum,p1); x=addrr(x,del);
    }
    it*=3;
    s[j]=ladd(gdivgs((GEN)s[j-1],3),gmul(sum,del));

    if (j>=KLOC)
    {
      for (j1=1; j1<=KLOC; j1++)
      {
	p3[j1]=s[j1+j-KLOC]; p4[j1]=h[j1+j-KLOC];
      }
      tetpil=avma; ss=polint(p4,p3,gzero,&dss);
      j1=gexpo(ss); j2=gexpo(dss); lim=((prec-2)<<TWOPOTBITS_IN_LONG)-(3*j/2)-5;
      if ( j1-j2 > lim || (j1 < -lim && j2<j1-1))
      {
	if (gcmp0(gimag(ss))) ss=greal(ss);
	tetpil=avma; killvalue(ep);
	return gerepile(av,tetpil,gmulsg(sig,ss));
      }
    }
    s[j+1]=s[j]; h[j+1]=ldivrs((GEN)h[j],9);
  }
  err(intger2);
  return NULL; /* not reached */
}

#undef JMAX
#define JMAX 16
#define JMAXP JMAX+3
#define KLOC 5

GEN
qromi(entree *ep, GEN a, GEN b, char *ch, long prec)
{
  GEN ss,dss,s,h,q1,sz,p1,p3,p4,p,qlint,del,ddel,x,sum;
  long av,tetpil,j,j1,j2,lim,l,it,tnm,sig;

  av=avma; l=prec;
  p=cgetr(prec); gaffect(ginv(a),p); a=p;
  p=cgetr(prec); gaffect(ginv(b),p); b=p;
  qlint=subrr(b,a); sig= -signe(qlint);
  if (!sig) { avma=av; return gzero; }
  if (sig>0) { setsigne(qlint,1); s=a; a=b; b=s; }

  newvalue(ep,cgetr(prec)); q1=(GEN)ep->value;
  p3=cgetg(KLOC+1,t_VEC); p4=cgetg(KLOC+1,t_VEC);
  s=cgetg(JMAXP,t_VEC); h=cgetg(JMAXP,t_VEC);
  affsr(1,(GEN)(h[1]=lgetr(l))); x=divsr(2,addrr(a,b));
  affrr(x,q1);
  p1=gmul(lisexpr(ch),mulrr(x,x)); s[1]=lmul(qlint,p1); it=1;
  sz=gmul(gzero,(GEN)s[1]); s[2]=s[1]; h[2]=ldivrs((GEN)h[1],9);
  for (j=2; j<=JMAX; j++)
  {
    tnm=it; del=divrs(qlint,3*tnm); ddel=shiftr(del,1);
    x=addrr(a,shiftr(del,-1)); sum=sz;
    for (j1=1; j1<=it; j1++)
    {
      divsrz(1,x,q1); p1=gmul(lisexpr(ch),mulrr(q1,q1));
      sum=gadd(sum,p1); x=addrr(x,ddel);
      divsrz(1,x,q1); p1=gmul(lisexpr(ch),mulrr(q1,q1));
      sum=gadd(sum,p1); x=addrr(x,del);
    }
    it*=3;
    s[j]=ladd(gdivgs((GEN)s[j-1],3),gmul(sum,del));
    if (j>=KLOC)
    {
      for (j1=1; j1<=KLOC; j1++)
      {
	p3[j1]=s[j1+j-KLOC]; p4[j1]=h[j1+j-KLOC];
      }
      tetpil=avma; ss=polint(p4,p3,gzero,&dss);
      j1=gexpo(ss); j2=gexpo(dss); lim=((prec-2)<<TWOPOTBITS_IN_LONG)-(3*j/2)-5;
      if (j1-j2 > lim || (j1 < -lim && j2 < j1-1))
      {
	if (gcmp0(gimag(ss))) ss=greal(ss);
	tetpil=avma; killvalue(ep);
	return gerepile(av,tetpil,gmulsg(sig,ss));
      }
    }
    s[j+1]=s[j]; h[j+1]=ldivrs((GEN)h[j],9);
  }
  err(intger2);
  return NULL; /* not reached */
}

GEN
rombint(entree *ep, GEN a, GEN b, char *ch, long prec)
{
  GEN aa,bb,p1,p2,p3;
  static long p4[3]={ evaltyp(t_INT)+evalpere(MAXPERE)+evallg(3),
                      evalsigne(-1)+evallgefint(3), 1 }; /* p4 = -1 */
  long   l,av,tetpil;

  l=gcmp(b,a); if (!l) return gzero;
  if (l<0) { bb=a; aa=b; } else { bb=b; aa=a; }
  av=avma;
  if (gcmpgs(bb,100)>=0)
  {
    if (gcmpgs(aa,1)>=0) return qromi(ep,a,b,ch,prec);
    p1=qromi(ep,gun,bb,ch,prec);
    if (gcmpgs(aa,-100)>=0)
    {
      p2=qromo(ep,aa,gun,ch,prec); tetpil=avma;
      return gerepile(av,tetpil,gmulsg(l,gadd(p1,p2)));
    }
    p2=qromo(ep,p4,gun,ch,prec); p3=gadd(p2,qromi(ep,aa,p4,ch,prec));
    tetpil=avma; return gerepile(av,tetpil,gmulsg(l,gadd(p1,p3)));
  }
  if (gcmpgs(aa,-100)>=0) return qromo(ep,a,b,ch,prec);
  if (gcmpgs(bb,-1)>=0)
  {
    p1=qromi(ep,aa,p4,ch,prec); p2=qromo(ep,p4,bb,ch,prec); tetpil=avma;
    return gerepile(av,tetpil,gmulsg(l,gadd(p1,p2)));
  }
  return qromi(ep,a,b,ch,prec);
}

/********************************************************************/
/**                                                                **/
/**                    SOMMATION DE SERIES                         **/
/**                                                                **/
/********************************************************************/

GEN
polzag(long n, long m)
{
  long d1,d,r,k,av=avma,tetpil;
  GEN p1,p2,pol1,g,s;

  if (m>=n || m<0)
    err(talker,"first index must be greater than second in polzag");
  d1=n-m; d=d1<<1; d1--; p1=gsub(gun,gmul2n(polx[0],1));
  pol1=gsub(gun,polx[0]); p2=gmul(polx[0],pol1); r=(m+1)>>1;
  g=gzero;
  for (k=0; k<=d1; k++)
  {
    s=binome(stoi(d),(k<<1)+1); if (k&1) s=negi(s);
    g=gadd(g,gmul(s,gmul(gpuigs(polx[0],k),gpuigs(pol1,d1-k))));
  }
  g=gmul(g,gpuigs(p2,r));
  if (!(m&1)) g=gadd(gmul(p1,g),gmul2n(gmul(p2,deriv(g,0)),1));
  for (k=1; k<=r; k++)
  {
    g=deriv(g,0); g=gadd(gmul(p1,g),gmul2n(gmul(p2,deriv(g,0)),1));
  }
  g = m ? gmul2n(g,(m-1)>>1):gmul2n(g,-1);
  s=mulsi(n-m,mpfact(m+1));
  tetpil=avma; return gerepile(av,tetpil,gdiv(g,s));
}

GEN
polzagreel(long n, long m, long prec)
{
  long d1,d,r,j,k,k2,av=avma,tetpil;
  GEN p2,pol1,g,h,v,b,gend,s,unreel;

  if (m>=n || m<0)
    err(talker,"first index must be greater than second in polzag");
  affsr(1,unreel=cgetr(prec));
  d1=n-m; d=d1<<1; d1--; pol1=gadd(gun,polx[0]);
  p2=gmul(polx[0],pol1); r=(m+1)>>1; gend=stoi(d);
  v=cgetg(d1+2,t_VEC); g=cgetg(d1+2,t_VEC);
  v[d1+1]=un; b=mulri(unreel,gend); g[d1+1]=(long)b;
  for (k=1; k<=d1; k++)
  {
    v[d1-k+1]=un;
    for (j=1; j<k; j++)
      v[d1-k+j+1]=(long)addii((GEN)v[d1-k+j+1],(GEN)v[d1-k+j+2]);
    k2=k+k; b=divri(mulri(b,mulss(d-k2+1,d-k2)),mulss(k2,k2+1));
    for (j=1; j<=k; j++)
      g[d1-k+j+1]=(long)mpadd((GEN)g[d1-k+j+1],mulri(b,(GEN)v[d1-k+j+1]));
    g[d1-k+1]=(long)b;
  }
  h=cgetg(d1+3,t_POL); h[1]=evalsigne(1)+evallgef(d1+3);
  for (k=0; k<=d1; k++) h[k+2]=g[k+1];
  g=gmul(h,gpuigs(p2,r));
  for (j=0; j<=r; j++)
  {
    if (j) g=deriv(g,0);
    if (j || !(m&1))
    {
      h=cgetg(n+3,t_POL); h[1]=evalsigne(1)+evallgef(n+3);
      h[2]=g[2];
      for (k=1; k<n; k++)
	h[k+2]=ladd(gmulsg(k+k+1,(GEN)g[k+2]),gmulsg(k<<1,(GEN)g[k+1]));
      h[n+2]=lmulsg(n<<1,(GEN)g[n+1]); g=h;
    }
  }
  g = m ?gmul2n(g,(m-1)>>1):gmul2n(g,-1);
  s=mulsi(n-m,mpfact(m+1));
  tetpil=avma; return gerepile(av,tetpil,gdiv(g,s));
}

GEN
sumalt0(entree *ep, GEN a, char *ch, long flag, long prec)
{
  switch(flag)
  {
    case 0: return sumalt(ep,a,ch,prec);
    case 1: return sumalt2(ep,a,ch,prec);
    default: err(flagerr);
  }
  return NULL; /* not reached */
}

GEN
sumpos0(entree *ep, GEN a, char *ch, long flag, long prec)
{
  switch(flag)
  {
    case 0: return sumpos(ep,a,ch,prec);
    case 1: return sumpos2(ep,a,ch,prec);
    default: err(flagerr);
  }
  return NULL; /* not reached */
}

GEN
sumalt(entree *ep, GEN a, char *ch, long prec)
{
  long av,tetpil,k,N;
  GEN  q1,s,az,c,x,e1,d;

  newvalue(ep,gun); q1=(GEN)ep->value; gaffect(a,q1);
  av=avma; affsr(1,cgetr(prec));
  e1=addsr(3,gsqrt(stoi(8),prec));
  N=(long)(0.4*(((prec-2)<<TWOPOTBITS_IN_LONG)+7));
  d=gpuigs(e1,N); d=shiftr(addrr(d,divsr(1,d)),-1);
  az=negi(gun); c=d; s=gzero;
  for (k=0; k<N; k++)
  {
    x=lisexpr(ch); c=gadd(az,c);
    if (DEBUGLEVEL>4) outerr(c);
    s=gadd(s,gmul(x,c));
    az=divii(mulii(mulss(N-k,N+k),shifti(az,1)),mulss(k+1,k+k+1));
    if (k<N-1) { a=gaddsg(1,a); gaffect(a,q1); }
  }
  tetpil=avma; killvalue(ep);
  return gerepile(av,tetpil,gdiv(s,d));
}

GEN
sumalt2(entree *ep, GEN a, char *ch, long prec)
{
  long av,tetpil,k,N;
  GEN  q1,s,dn,pol;

  newvalue(ep,gun); q1=(GEN)ep->value; gaffect(a,q1);
  av=avma;
  N=(long)(0.31*(((prec-2)<<TWOPOTBITS_IN_LONG)+5));
  s=gzero; pol=polzagreel(N,N>>1,prec+1); dn=gsubst(pol,0,gun);
  pol[2]=lsub((GEN)pol[2],dn); pol=gdiv(pol,gsub(polx[0],gun));
  N=lgef(pol)-2;
  for (k=0; k<N; k++)
  {
    s=gadd(s,gmul(lisexpr(ch),(GEN)pol[k+2]));
    if (k<N-1) { a=gaddsg(1,a); gaffect(a,q1); }
  }
  tetpil=avma; killvalue(ep);
  return gerepile(av,tetpil,gdiv(s,dn));
}

GEN
sumpos(entree *ep, GEN a, char *ch, long prec)
{
  long av,tetpil,k,kk,N;
  GEN  p1,r,q1,unreel,s,az,c,x,e1,d,stock;

  av=avma; a=gsubgs(a,1); affsr(1,unreel=cgetr(prec));
  e1=addsr(3,gsqrt(stoi(8),prec));
  N=(long)(0.4*(((prec-2)<<TWOPOTBITS_IN_LONG)+7));
  stock=cgetg(N+1,t_VEC); for (k=1; k<=N; k++) stock[k]=(long)NULL;
  d=gpuigs(e1,N); d=shiftr(addrr(d,divsr(1,d)),-1);
  az=negi(gun); c=d; s=gzero;
  p1=cgeti(prec+2); p1[1]=evalsigne(1)+evallgefint(2+prec);
  newvalue(ep,p1); q1=(GEN)ep->value;
  for (k=0; k<N; k++)
  {
    if (odd(k) && stock[k]) x=(GEN)stock[k];
    else
    {
      x=gzero; r=stoi(2*k+2); kk=0;
      do
      {
	gaddz(r,a,q1); p1=gmul2n(gmul(unreel,lisexpr(ch)),kk);
	x=gadd(x,p1); r=shifti(r,1); kk++;
      }
      while (kk<=1 || gexpo(p1)>=(-((prec-2)<<TWOPOTBITS_IN_LONG)+5));
      if (2*k<N) stock[2*k+1]=(long)x;
      r=stoi(k+1); gaddz(r,a,q1);
      x=gadd(gmul(unreel,lisexpr(ch)),gmul2n(x,1));
    }
    c=gadd(az,c); s=odd(k)?gsub(s,gmul(x,c)):gadd(s,gmul(x,c));
    if (DEBUGLEVEL>4) outerr(c);
    az=divii(mulii(mulss(N-k,N+k),shifti(az,1)),mulss(k+1,k+k+1));
  }
  tetpil=avma; killvalue(ep);
  return gerepile(av,tetpil,gdiv(s,d));
}

GEN
sumpos2(entree *ep, GEN a, char *ch, long prec)
{
  long av,tetpil,k,kk,N;
  GEN p1,r,q1,unreel,s,pol,dn,x,stock;

  av=avma; a=gsubgs(a,1); affsr(1,unreel=cgetr(prec));
  N=(long)(0.31*(((prec-2)<<TWOPOTBITS_IN_LONG)+5));
  stock=cgetg(N+1,t_VEC); for (k=0; k<N; k++) stock[k+1]=(long)NULL;
  p1=cgeti(prec+1); p1[1]=evalsigne(1)+evallgefint(1+prec);
  newvalue(ep,p1); q1=(GEN)ep->value;
  for (k=0; k<N; k++)
  {
    if (!odd(k) || !stock[k+1])
    {
      x=gzero; r=stoi(2*k+2); kk=0;
      do
      {
	gaddz(r,a,q1); p1=gmul2n(gmul(unreel,lisexpr(ch)),kk);
	x=gadd(x,p1); r=shifti(r,1); kk++;
      }
      while ((kk<=1)||(gexpo(p1)>=(-((prec-2)<<TWOPOTBITS_IN_LONG)+5)));
      if (2*k+1<N) stock[2*k+2]=(long)x;
      r=stoi(k+1); gaddz(r,a,q1);
      stock[k+1]=(long)gadd(gmul(unreel,lisexpr(ch)),gmul2n(x,1));
    }
  }
  killvalue(ep);
  s=gzero; pol=polzagreel(N,N>>1,prec+1); dn=gsubst(pol,0,gun);
  pol[2]=lsub((GEN)pol[2],dn); pol=gdiv(pol,gsub(gun,polx[0]));
  for (k=0; k<=lgef(pol)-3; k++)
  {
    if (k%2) s=gadd(s,gmul((GEN)pol[k+2],(GEN)stock[k+1]));
    else s=gsub(s,gmul((GEN)pol[k+2],(GEN)stock[k+1]));
  }
  tetpil=avma; return gerepile(av,tetpil,gdiv(s,dn));
}

/********************************************************************/
/**                                                                **/
/**                  RECHERCHE DE ZEROS REELS                      **/
/**                                                                **/
/********************************************************************/

GEN
zbrent(entree *ep, GEN a, GEN b, char *ch, long prec)
{
  long av=avma,tetpil,sig,iter,itmax;
  GEN q1,c,d,e,tol,toli,min1,min2,fa,fb,fc,p,q,r,s,xm;

  if (typ(a)!=t_REAL) { p=cgetr(prec); gaffect(a,p); a=p; }
  if (typ(b)!=t_REAL) { p=cgetr(prec); gaffect(b,p); b=p; }
  sig=cmprr(b,a); if (!sig) { avma = av; return gzero; }
  if (sig<0) { c=a; a=b; b=c; }
  newvalue(ep,a); fa=lisexpr(ch);
  changevalue(ep,b); q1=(GEN)ep->value; fb=lisexpr(ch);
  if (gsigne(fa)*gsigne(fb)>0) err(zbrenter1);
  itmax=(prec<<TWOPOTBITS_IN_LONG)+50; affsr(1,tol=cgetr(3));
  tol=shiftr(tol,-(((prec-2)<<TWOPOTBITS_IN_LONG)-5));
  fc=fb;
  for (iter=1; iter<=itmax; iter++)
  {
    if (gsigne(fb)*gsigne(fc)>0)
    {
      c=a; fc=fa; d=subrr(b,a); e=d;
    }
    if (gcmp(gabs(fc,0),gabs(fb,0))<0)
    {
      a=b; b=c; c=a; fa=fb; fb=fc; fc=fa;
    }
    toli=mulrr(tol,absr(b));
    xm=shiftr(subrr(c,b),-1);
    if ((cmprr(absr(xm),toli)<=0)||gcmp0(fb))
    {
      tetpil=avma;
      killvalue(ep);
      return gerepile(av,tetpil,gcopy(b));
    }
    if ((cmprr(absr(e),toli)>=0)&&(gcmp(gabs(fa,0),gabs(fb,0))>0))
    {
      s=gdiv(fb,fa);
      if (cmprr(a,b)==0)
      {
	p=gmul2n(gmul(xm,s),1); q=gsubsg(1,s);
      }
      else
      {
	q=gdiv(fa,fc); r=gdiv(fb,fc);
	p=gmul2n(gmul(gsub(q,r),gmul(xm,q)),1);
	p=gmul(s,gsub(p,gmul(gsub(b,a),gsubgs(r,1))));
	q=gmul(gmul(gsubgs(q,1),gsubgs(r,1)),gsubgs(s,1));
      }
      if (gsigne(p)>0) q=gneg(q);
      p=gabs(p,0);
      min1=gsub(gmulsg(3,gmul(xm,q)),gabs(gmul(q,toli),0));
      min2=gabs(gmul(e,q),0);
      if (gcmp(gmul2n(p,1),gmin(min1,min2))<0) { e=d; d=gdiv(p,q); }
      else { d=xm; e=d; }
    }
    else { d=xm; e=d; }
    a=b; fa=fb;
    if (gcmp(gabs(d,0),toli)>0) b=addrr(b,d);
    else
    {
      if (gsigne(xm)>0) b=addrr(b,absr(toli));
      else b=subrr(b,absr(toli));
    }
    gaffect(b,q1); ; fb=lisexpr(ch);
  }
  err(zbrenter2);
  return NULL; /* not reached */
}

/***********************************************************************/
/*                                                                     */
/*                          SET OPERATIONS                             */
/*                                                                     */
/***********************************************************************/

GEN
gtoset(GEN x)
{
  long tx=typ(x),av=avma,tetpil,c,i,ly;
  GEN y,z;

  if (! is_vec_t(tx)) y=gtovec(x); else y=x;
  ly=lg(y); if (ly==1) { avma=av; return cgetg(1,t_VEC); }
  y=sort(y); z=cgetg(ly,t_VEC);
  c=1; z[1]=y[1];
  for (i=2; i<ly; i++)
    if (!gegal((GEN)y[i],(GEN)z[c])) z[++c]=y[i];
  tetpil=avma; y=cgetg(c+1,t_VEC); for (i=1; i<=c; i++) y[i]=lcopy((GEN)z[i]);
  return gerepile(av,tetpil,y);
}

long
isvecset(GEN x)
{
  long lx,i;

  if (typ(x)!=t_VEC) return 0;
  lx=lg(x);
  for (i=1; i<lx-1; i++)
    if (gcmp((GEN)x[i+1],(GEN)x[i])<=0) return 0;
  return 1;
}

/* looks if y belongs to the set x and returns the index if yes, 0 if no */
long setsearch(GEN x, GEN y)
{
  long lx,j,li,ri,fl;

  if (!isvecset(x)) err(talker,"not a set in setsearch");
  lx=lg(x); li=1; ri=lx-1;
  while (ri>=li)
  {
    j = (ri+li)>>1;
    fl=gcmp((GEN)x[j],y);
    if (!fl) return j;
    if (fl<0) li=j+1; else ri=j-1;
  }
  return 0;
}

GEN
setunion(GEN x, GEN y)
{
  long av=avma,tetpil;
  GEN z;

  if (!isvecset(x) || !isvecset(y)) err(talker,"not a set in setunion");
  z=concat(x,y); tetpil=avma; return gerepile(av,tetpil,gtoset(z));
}

GEN
setintersect(GEN x, GEN y)
{
  long av=avma,tetpil,i,lx,c;
  GEN z,p1;

  if (!isvecset(x) || !isvecset(y)) err(talker,"not a set in setintersect");
  lx=lg(x); z=cgetg(lx,t_VEC); c=0;
  for (i=1; i<lx; i++) { p1=(GEN)x[i]; if (setsearch(y,p1)) z[++c]=(long)p1; }
  tetpil=avma; p1=cgetg(c+1,t_VEC);
  for (i=1; i<=c; i++) p1[i]=lcopy((GEN)z[i]);
  return gerepile(av,tetpil,p1);
}

GEN
setminus(GEN x, GEN y)
{
  long av=avma,tetpil,i,lx,c;
  GEN z,p1;

  if (!isvecset(x) || !isvecset(y)) err(talker,"not a set in setintersect");
  lx=lg(x); z=cgetg(lx,t_VEC); c=0;
  for (i=1; i<lx; i++) { p1=(GEN)x[i]; if (!setsearch(y,p1)) z[++c]=(long)p1; }
  tetpil=avma; p1=cgetg(c+1,t_VEC);
  for (i=1; i<=c; i++) p1[i]=lcopy((GEN)z[i]);
  return gerepile(av,tetpil,p1);
}

/***********************************************************************/
/*                                                                     */
/*               OPERATIONS ON DIRICHLET SERIES                        */
/*                                                                     */
/***********************************************************************/

/* Addition, subtraction and scalar multiplication of Dirichlet series
   are done on the corresponding vectors */

static long
dirval(GEN x)
{
/* a usage interne, pas de verifs */
  long i=1,lx=lg(x);
  while (i<lx && gcmp0((GEN)x[i])) i++;
  return i;
}

GEN
dirmul(GEN x, GEN y)
{
  long lx,ly,lz,dx,dy,av,tetpil,i,j;
  GEN z,p1;

  if (typ(x)!=t_VEC || typ(y)!=t_VEC) err(talker,"not a dirseries in dirmul");
  av=avma; dx=dirval(x); dy=dirval(y); lx=lg(x); ly=lg(y);
  if (ly-dy<lx-dx) { z=y; y=x; x=z; lz=ly; ly=lx; lx=lz; lz=dy; dy=dx; dx=lz; }
  lz=min(lx*dy,ly*dx);
  z=cgetg(lz,t_VEC); for (i=1; i<lz; i++) z[i]=zero;
  for (j=dx; j<lx; j++)
  {
    p1=(GEN)x[j];
    if (!gcmp0(p1))
    {
      if (gcmp1(p1))
	for (i=j*dy; i<lz; i+=j) z[i]=ladd((GEN)z[i],(GEN)y[i/j]);
      else
      {
	if (gcmp_1(p1))
	  for (i=j*dy; i<lz; i+=j) z[i]=lsub((GEN)z[i],(GEN)y[i/j]);
	else
	  for (i=j*dy; i<lz; i+=j) z[i]=ladd((GEN)z[i],gmul(p1,(GEN)y[i/j]));
      }
    }
  }
  tetpil=avma; return gerepile(av,tetpil,gcopy(z));
}

GEN
dirdiv(GEN x, GEN y)
{
  long lx,ly,lz,dx,dy,av,tetpil,i,j;
  GEN z,p1;

  if (typ(x)!=t_VEC || typ(y)!=t_VEC) err(talker,"not a dirseries in dirmul");
  av=avma; dx=dirval(x); dy=dirval(y); lx=lg(x); ly=lg(y);
  if (dy!=1) err(talker,"not an invertible dirseries in dirdiv");
  lz=min(lx,ly*dx); p1=(GEN)y[1];
  if (!gcmp1(p1)) { y=gdiv(y,p1); x=gdiv(x,p1); }
  else x=gcopy(x);
  z=cgetg(lz,t_VEC); for (i=1; i<dx; i++) z[i]=zero;
  for (j=dx; j<lz; j++)
  {
    p1=(GEN)x[j]; z[j]=(long)p1;
    if (!gcmp0(p1))
    {
      if (gcmp1(p1))
	for (i=j+j; i<lz; i+=j) x[i]=lsub((GEN)x[i],(GEN)y[i/j]);
      else
      {
	if (gcmp_1(p1))
	  for (i=j+j; i<lz; i+=j) x[i]=ladd((GEN)x[i],(GEN)y[i/j]);
	else
	  for (i=j+j; i<lz; i+=j) x[i]=lsub((GEN)x[i],gmul(p1,(GEN)y[i/j]));
      }
    }
  }
  tetpil=avma; return gerepile(av,tetpil,gcopy(z));
}

GEN
dirzetak(GEN nf, GEN b)
{
  long av=avma,tetpil,av1,lim,i,j,lx,bs,c,q,p2s;
  byteptr d=diffptr;
  GEN p,p1,p2,z,z2,pol;

  if (typ(nf)!=t_VEC || lg(nf)<10) err(idealer1);
  lim=(avma+bot)>>1; pol=(GEN)nf[1];
  if (typ(b)!=t_INT) err(talker,"not an integer type in dirzeta");
  if (signe(b)<=0) b=gun;
  if (gcmpgs(b,MAXLEN)>=0) bs=MAXLEN;
  else bs=itos(b)+1;
  p=cgeti(3); p[1]=evalsigne(1)+evallgefint(3); p[2]=2; c= *d++;
  av1=avma;
  z=cgetg(bs,t_VEC); z[1]=un; for (i=2; i<bs; i++) z[i]=zero;
  do
  {
    if (smodis((GEN)nf[4],p[2]))
    { p1=(GEN)simplefactmod(pol,p)[1]; lx=lg(p1); }
    else
    {
      p2=primedec(nf,p); lx=lg(p2); p1=cgetg(lx,t_COL);
      for (i=1; i<lx; i++) p1[i]=((GEN)p2[i])[4];
    }
    for (j=1; j<lx; j++)
    {
      p2=gpuigs(p,itos((GEN)p1[j]));
      if (gcmpgs(p2,bs)<0)
      {
	z2=gcopy(z); q=p2s=itos(p2);
	while (q<bs)
	{
	  for (i=q; i<bs; i+=q) z2[i]=ladd((GEN)z2[i],(GEN)z[i/q]);
	  q*=p2s;
	 }
	z=z2;
      }
    }
    if (avma<lim) { tetpil=avma; z=gerepile(av1,tetpil,gcopy(z)); }
    c=*d++; p[2]+=c;
  }
  while (c && p[2]<bs);
  tetpil=avma; return gerepile(av,tetpil,gcopy(z));
}

/*************************************************************************/
/**									**/
/**			         RANDOM					**/
/**									**/
/*************************************************************************/

long
mymyrand()
{
/* BSD rand gives this: pari_randseed=1103515245*pari_randseed+12345; */
#ifdef LONG_IS_64BIT
  if (BITS_IN_RANDOM==64)
    pari_randseed = 1000000000000654397*pari_randseed + 12347;
  else
    pari_randseed = (1000276549*pari_randseed + 12347) % 2147483648;
#else
  pari_randseed=1000276549*pari_randseed+12347;
  if (pari_randseed<0) pari_randseed+=HIGHBIT;
#endif
  return pari_randseed;
}

GEN
genrand(void) { return stoi(mymyrand()); }

GEN
setrand(long seed) { return stoi(pari_randseed = seed); }

GEN
getrand() { return stoi(pari_randseed); }

GEN
getstack() { return stoi(top-avma); }

GEN
gettime() { return stoi(timer2()); }

/***********************************************************************/
/**							              **/
/**       		     PERMUTATIONS                             **/
/**								      **/
/***********************************************************************/

GEN
permute(long n, GEN x)
{
  long av=avma,tetpil,i,a,r;
  GEN v,w,y;

  v=cgetg(n+1,t_VEC); v[1]=1;
  for (r=2; r<=n; r++)
  {
    x=dvmdis(x,r,&w); a=itos(w);
    for (i=r; i>=a+2; i--) v[i]=v[i-1];
    v[a+1]=r;
  }
  tetpil=avma; y=cgetg(n+1,t_VEC);
  for (i=1; i<=n; i++) y[i]=lstoi(v[i]);
  return gerepile(av,tetpil,y);
}

GEN
permuteInv(GEN x)
{
  long av=avma,tetpil, len=lg(x)-1, last, ind;
  long ini=len;
  GEN ary,res;

  if (typ(x)!=t_VEC && typ(x)!=t_COL) err(talker,"not a vector in permuteInv");
  res=gzero; ary=cgetg(len+1,t_VEC);
  for (ind=1; ind<=len; ind++) ary[ind]=*++x;
  ary++;
  for (last=len; last>0; last--)
  {
    len--; ind=len;
    while (ind>0 && itos((GEN)ary[ind])!=last) ind--;
    res=mulis(res,last); tetpil=avma; res=addis(res,ind);
    while (ind++<len) ary[ind-1]=ary[ind];
  }
  if (!signe(res)) { tetpil=avma; res=mpfact(ini); }
  return gerepile(av,tetpil,res);
}

/********************************************************************/
/**                                                                **/
/**                       MODREVERSE                               **/
/**                                                                **/
/********************************************************************/

GEN
polymodrecip(GEN x)
{
  long v,i,j,n,av,tetpil,lx;
  GEN p1,p2,p3,p,phi,y,col;

  if (typ(x)!=t_POLMOD) err(polymoder1);
  p=(GEN)x[1]; phi=(GEN)x[2];
  v=varn(p); n=lgef(p)-3; if (n<=0) return gcopy(x);
  if (n==1)
  {
    y=cgetg(3,t_POLMOD); p1=cgetg(4,t_POL); y[1]=(long)p1;
    p1[1]=p[1]; p1[2]= (typ(phi)==t_POL) ? lneg((GEN)phi[2]) : lneg(phi);
    p1[3]=un; p1=cgetg(3,t_POL); y[2]=(long)p1;
    if (gcmp0((GEN)p[2])) p1[1]=2;
    else
    {
      p1[1]=p[1]-1; av=avma; p2=gdiv((GEN)p[2],(GEN)p[3]);
      tetpil=avma; p1[2]=lpile(av,tetpil,gneg(p2));
    }
    setvarn(p1,v);
    return y;
  }
  if (gcmp0(phi)) err(polymoder2);
  av=avma; y=cgetg(n+1,t_MAT); p1=cgetg(n+1,t_COL);
  y[1]=(long)p1; p1[1]=un; for (i=2; i<=n; i++) p1[i]=zero;
  p2=phi;
  for (j=2; j<=n; j++)
  {
    lx=lgef(p2); p1=cgetg(n+1,t_COL); y[j]=(long)p1;
    for (i=1; i<=lx-2; i++) p1[i]=p2[i+1];
    for (i=lx-1; i<=n; i++) p1[i]=zero;
    if (j<n) p2=gmod(gmul(p2,phi),p);
  }
  col=cgetg(n+1,t_COL); col[1]=zero; col[2]=un;
  for (i=3; i<=n; i++) col[i]=zero;
  p1=gauss(y,col); p2=gtopolyrev(p1,v); p3=caract(x,v);
  tetpil=avma; return gerepile(av,tetpil,gmodulcp(p2,p3));
}
